require 'spec_helper'

describe "Hodor says" do
  before do
    $stdout = StringIO.new
  end
  after do
    $stdout = STDOUT
  end

  [['print', 'hodor_prints'], ['puts', 'hodor_says'], ['p', 'hodor']].each do |pair|
    it "adds 'Hodor!' to anything printed by #{pair[0]}" do
      send(pair[0].to_sym, "test")
      expect($stdout.string).to match(/test/)
      expect($stdout.string).to match(/Hodor!/)
    end

    it "uses alias '#{pair[1]}'" do
      send(pair[1].to_sym, "test")
      expect($stdout.string).to match(/test/)
      expect($stdout.string).to match(/Hodor!/)
    end
  end
end